use std::process::exit;

use log::error;
use sea_orm::entity::prelude::*;
use serde::{Deserialize,Serialize};
use crate::parse_json::json_object;
pub use renew::add_to_database as add_to_database;
pub mod tests;
pub mod renew;

#[derive(Clone, Debug, PartialEq, Eq, DeriveEntityModel,Serialize,Deserialize)]
#[sea_orm(table_name = "words")]
pub struct Model{
    #[sea_orm(primary_key)]
    #[serde(skip)]
    pub id: i32,
    pub bsm: String,
    pub hz:String,
    #[serde(alias="pyJs")]
    pub py_js: String,
}

impl From<json_object::Word> for Model{
    fn from(obj:json_object::Word)->Self{
        Model{
            id:0,
            bsm:obj.bsm,
            hz:obj.hz,
            py_js:match serde_json::to_string(&obj.py_js) {
                Ok(o)=>o,
                Err(e)=>{
                    error!("Cannot let {:?} parse to String",obj.py_js);
                    error!("{}",e);
                    exit(1);
                }
            }
        }
    }
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    // #[sea_orm(has_many = "super::fruit::Entity")]
    // Fruit,
}

// impl Related<super::fruit::Entity> for Entity {
//     fn to() -> RelationDef {
//         Relation::Fruit.def()
//     }
// }

impl ActiveModelBehavior for ActiveModel {}